#ifndef MARS_MRanForestGrow
#define MARS_MRanForestGrow

#ifndef MARS_MTask
#include "MTask.h"
#endif

#include "TRandom.h"
#include "TMath.h"

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// MRanForestGrow                                                          //
//                                                                         //
// Task to grow (train) a random forest                                    //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#include "MRanForest.h"

class MHMatrix;
class MParList;
class MRanForest;

class MRanForestGrow : public MTask
{
private:
    MRanTree   *fRanTree;
    MRanForest *fRanForest;
    MHMatrix   *fMGammas;   //! Gammas describing matrix
    MHMatrix   *fMHadrons;  //! Hadrons (non gammas) describing matrix

    Int_t fNumTrees;
    Int_t fNumTry;
    Int_t fNdSize;

public:
    MRanForestGrow(const char *name=NULL, const char *title=NULL);

    void SetNumTrees(Int_t n);
    void SetNumTry(Int_t n);
    void SetNdSize(Int_t n);

    Bool_t PreProcess(MParList *pList);
    Bool_t Process();
    Bool_t PostProcess();

    ClassDef(MRanForestGrow, 0) // Task to grow a random forest
};

#endif

