#ifndef MARS_MHRanForest
#define MARS_MHRanForest

#ifndef MARS_MH
#include "MH.h"
#endif

#ifndef TArrayF
#include "TArrayF.h"
#endif

class TH1D;
class TGraph;
class MParList;
class MMcEvt;
class MRanForest;

class MHRanForest : public MH
{
private:
    const MMcEvt *fMcEvt;
    const MRanForest *fRanForest;

    TArrayF fSigma;
    Int_t fNumEvent;
    TGraph *fGraphSigma;

public:
    MHRanForest(Int_t nbins=100, const char *name=NULL, const char *title=NULL);
    ~MHRanForest();

    TGraph *GetGrphSigma() const  { return fGraphSigma; }

    Bool_t SetupFill(const MParList *plist);
    Bool_t Fill(const MParContainer *par);
    Bool_t Finalize();

    void Print(Option_t *option="") const;

    void Draw(Option_t *opt="");
    TObject *DrawClone(Option_t *opt="") const;

    ClassDef(MHRanForest, 1) // Histogram showing variance of estimated Hadronness
};

#endif
